diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/csma/model/csma-net-device.h ns-3.40/src/csma/model/csma-net-device.h
--- ns-3.39/src/csma/model/csma-net-device.h	2023-07-05 14:23:47.773427200 -0700
+++ ns-3.40/src/csma/model/csma-net-device.h	2023-09-27 13:30:37.638839000 -0700
@@ -20,8 +20,9 @@
 #ifndef CSMA_NET_DEVICE_H
 #define CSMA_NET_DEVICE_H
 
+#include "backoff.h"
+
 #include "ns3/address.h"
-#include "ns3/backoff.h"
 #include "ns3/callback.h"
 #include "ns3/data-rate.h"
 #include "ns3/mac48-address.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/csma-layout/model/csma-star-helper.cc ns-3.40/src/csma-layout/model/csma-star-helper.cc
--- ns-3.39/src/csma-layout/model/csma-star-helper.cc	2023-07-05 14:23:47.773427200 -0700
+++ ns-3.40/src/csma-layout/model/csma-star-helper.cc	2023-09-27 13:30:37.638839000 -0700
@@ -13,16 +13,16 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
 
-#include <iostream>
-#include <sstream>
+#include "csma-star-helper.h"
 
-// ns3 includes
-#include "ns3/csma-star-helper.h"
 #include "ns3/log.h"
 #include "ns3/node-list.h"
 #include "ns3/point-to-point-net-device.h"
 #include "ns3/vector.h"
 
+#include <iostream>
+#include <sstream>
+
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsdv/model/dsdv-packet-queue.cc ns-3.40/src/dsdv/model/dsdv-packet-queue.cc
--- ns-3.39/src/dsdv/model/dsdv-packet-queue.cc	2023-07-05 14:23:47.773427200 -0700
+++ ns-3.40/src/dsdv/model/dsdv-packet-queue.cc	2023-09-27 13:30:37.638839000 -0700
@@ -56,7 +56,7 @@
     NS_LOG_FUNCTION("Enqueuing packet destined for" << entry.GetIpv4Header().GetDestination());
     Purge();
     uint32_t numPacketswithdst;
-    for (std::vector<QueueEntry>::const_iterator i = m_queue.begin(); i != m_queue.end(); ++i)
+    for (auto i = m_queue.begin(); i != m_queue.end(); ++i)
     {
         if ((i->GetPacket()->GetUid() == entry.GetPacket()->GetUid()) &&
             (i->GetIpv4Header().GetDestination() == entry.GetIpv4Header().GetDestination()))
@@ -86,7 +86,7 @@
 {
     NS_LOG_FUNCTION("Dropping packet to " << dst);
     Purge();
-    for (std::vector<QueueEntry>::iterator i = m_queue.begin(); i != m_queue.end(); ++i)
+    for (auto i = m_queue.begin(); i != m_queue.end(); ++i)
     {
         if (i->GetIpv4Header().GetDestination() == dst)
         {
@@ -104,7 +104,7 @@
 {
     NS_LOG_FUNCTION("Dequeueing packet destined for" << dst);
     Purge();
-    for (std::vector<QueueEntry>::iterator i = m_queue.begin(); i != m_queue.end(); ++i)
+    for (auto i = m_queue.begin(); i != m_queue.end(); ++i)
     {
         if (i->GetIpv4Header().GetDestination() == dst)
         {
@@ -119,7 +119,7 @@
 bool
 PacketQueue::Find(Ipv4Address dst)
 {
-    for (std::vector<QueueEntry>::const_iterator i = m_queue.begin(); i != m_queue.end(); ++i)
+    for (auto i = m_queue.begin(); i != m_queue.end(); ++i)
     {
         if (i->GetIpv4Header().GetDestination() == dst)
         {
@@ -134,7 +134,7 @@
 PacketQueue::GetCountForPacketsWithDst(Ipv4Address dst)
 {
     uint32_t count = 0;
-    for (std::vector<QueueEntry>::const_iterator i = m_queue.begin(); i != m_queue.end(); ++i)
+    for (auto i = m_queue.begin(); i != m_queue.end(); ++i)
     {
         if (i->GetIpv4Header().GetDestination() == dst)
         {
@@ -166,7 +166,7 @@
 {
     // NS_LOG_DEBUG("Purging Queue");
     IsExpired pred;
-    for (std::vector<QueueEntry>::iterator i = m_queue.begin(); i != m_queue.end(); ++i)
+    for (auto i = m_queue.begin(); i != m_queue.end(); ++i)
     {
         if (pred(*i))
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsdv/model/dsdv-routing-protocol.cc ns-3.40/src/dsdv/model/dsdv-routing-protocol.cc
--- ns-3.39/src/dsdv/model/dsdv-routing-protocol.cc	2023-07-05 14:23:47.773427200 -0700
+++ ns-3.40/src/dsdv/model/dsdv-routing-protocol.cc	2023-09-27 13:30:37.638839000 -0700
@@ -241,9 +241,7 @@
 RoutingProtocol::DoDispose()
 {
     m_ipv4 = nullptr;
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::iterator iter = m_socketAddresses.begin();
-         iter != m_socketAddresses.end();
-         iter++)
+    for (auto iter = m_socketAddresses.begin(); iter != m_socketAddresses.end(); iter++)
     {
         iter->first->Close();
     }
@@ -304,9 +302,7 @@
                                  << ", Destination address in Packet: " << dst);
     RoutingTableEntry rt;
     m_routingTable.Purge(removedAddresses);
-    for (std::map<Ipv4Address, RoutingTableEntry>::iterator rmItr = removedAddresses.begin();
-         rmItr != removedAddresses.end();
-         ++rmItr)
+    for (auto rmItr = removedAddresses.begin(); rmItr != removedAddresses.end(); ++rmItr)
     {
         rmItr->second.SetEntriesChanged(true);
         rmItr->second.SetSeqNo(rmItr->second.GetSeqNo() + 1);
@@ -428,9 +424,7 @@
             return true;
         }
     }
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j = m_socketAddresses.begin();
-         j != m_socketAddresses.end();
-         ++j)
+    for (auto j = m_socketAddresses.begin(); j != m_socketAddresses.end(); ++j)
     {
         Ipv4InterfaceAddress iface = j->second;
         if (origin == iface.GetLocal())
@@ -439,9 +433,7 @@
         }
     }
     // LOCAL DELIVARY TO DSDV INTERFACES
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j = m_socketAddresses.begin();
-         j != m_socketAddresses.end();
-         ++j)
+    for (auto j = m_socketAddresses.begin(); j != m_socketAddresses.end(); ++j)
     {
         Ipv4InterfaceAddress iface = j->second;
         if (m_ipv4->GetInterfaceForAddress(iface.GetLocal()) == iif)
@@ -545,7 +537,7 @@
     // If RouteOutput() caller specified an outgoing interface, that
     // further constrains the selection of source address
     //
-    std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j = m_socketAddresses.begin();
+    auto j = m_socketAddresses.begin();
     if (oif)
     {
         // Iterate to find an address on the oif device
@@ -592,10 +584,7 @@
         packet->RemoveHeader(dsdvHeader);
         NS_LOG_DEBUG("Processing new update for " << dsdvHeader.GetDst());
         /*Verifying if the packets sent by me were returned back to me. If yes, discarding them!*/
-        for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j =
-                 m_socketAddresses.begin();
-             j != m_socketAddresses.end();
-             ++j)
+        for (auto j = m_socketAddresses.begin(); j != m_socketAddresses.end(); ++j)
         {
             Ipv4InterfaceAddress interface = j->second;
             if (dsdvHeader.GetDst() == interface.GetLocal())
@@ -661,9 +650,7 @@
                 RoutingTableEntry tr;
                 std::map<Ipv4Address, RoutingTableEntry> allRoutes;
                 m_advRoutingTable.GetListOfAllRoutes(allRoutes);
-                for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator i = allRoutes.begin();
-                     i != allRoutes.end();
-                     ++i)
+                for (auto i = allRoutes.begin(); i != allRoutes.end(); ++i)
                 {
                     NS_LOG_DEBUG("ADV table routes are:" << i->second.GetDestination());
                 }
@@ -800,10 +787,7 @@
                     advTableEntry.SetSeqNo(dsdvHeader.GetDstSeqno());
                     advTableEntry.SetEntriesChanged(true);
                     m_advRoutingTable.Update(advTableEntry);
-                    for (std::map<Ipv4Address, RoutingTableEntry>::iterator i =
-                             dstsWithNextHopSrc.begin();
-                         i != dstsWithNextHopSrc.end();
-                         ++i)
+                    for (auto i = dstsWithNextHopSrc.begin(); i != dstsWithNextHopSrc.end(); ++i)
                     {
                         i->second.SetSeqNo(i->second.GetSeqNo() + 1);
                         i->second.SetEntriesChanged(true);
@@ -844,17 +828,13 @@
     NS_LOG_FUNCTION(m_mainAddress << " is sending a triggered update");
     std::map<Ipv4Address, RoutingTableEntry> allRoutes;
     m_advRoutingTable.GetListOfAllRoutes(allRoutes);
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j = m_socketAddresses.begin();
-         j != m_socketAddresses.end();
-         ++j)
+    for (auto j = m_socketAddresses.begin(); j != m_socketAddresses.end(); ++j)
     {
         DsdvHeader dsdvHeader;
         Ptr<Socket> socket = j->first;
         Ipv4InterfaceAddress iface = j->second;
         Ptr<Packet> packet = Create<Packet>();
-        for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator i = allRoutes.begin();
-             i != allRoutes.end();
-             ++i)
+        for (auto i = allRoutes.begin(); i != allRoutes.end(); ++i)
         {
             NS_LOG_LOGIC("Destination: " << i->second.GetDestination()
                                          << " SeqNo:" << i->second.GetSeqNo()
@@ -930,16 +910,12 @@
         return;
     }
     NS_LOG_FUNCTION(m_mainAddress << " is sending out its periodic update");
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j = m_socketAddresses.begin();
-         j != m_socketAddresses.end();
-         ++j)
+    for (auto j = m_socketAddresses.begin(); j != m_socketAddresses.end(); ++j)
     {
         Ptr<Socket> socket = j->first;
         Ipv4InterfaceAddress iface = j->second;
         Ptr<Packet> packet = Create<Packet>();
-        for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator i = allRoutes.begin();
-             i != allRoutes.end();
-             ++i)
+        for (auto i = allRoutes.begin(); i != allRoutes.end(); ++i)
         {
             DsdvHeader dsdvHeader;
             if (i->second.GetHop() == 0)
@@ -966,10 +942,7 @@
                          << ", HopCount:" << dsdvHeader.GetHopCount()
                          << ", LifeTime: " << i->second.GetLifeTime().As(Time::S));
         }
-        for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator rmItr =
-                 removedAddresses.begin();
-             rmItr != removedAddresses.end();
-             ++rmItr)
+        for (auto rmItr = removedAddresses.begin(); rmItr != removedAddresses.end(); ++rmItr)
         {
             DsdvHeader removedHeader;
             removedHeader.SetDst(rmItr->second.GetDestination());
@@ -1143,9 +1116,7 @@
 Ptr<Socket>
 RoutingProtocol::FindSocketWithInterfaceAddress(Ipv4InterfaceAddress addr) const
 {
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j = m_socketAddresses.begin();
-         j != m_socketAddresses.end();
-         ++j)
+    for (auto j = m_socketAddresses.begin(); j != m_socketAddresses.end(); ++j)
     {
         Ptr<Socket> socket = j->first;
         Ipv4InterfaceAddress iface = j->second;
@@ -1181,9 +1152,7 @@
     Ptr<Ipv4Route> route;
     std::map<Ipv4Address, RoutingTableEntry> allRoutes;
     m_routingTable.GetListOfAllRoutes(allRoutes);
-    for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator i = allRoutes.begin();
-         i != allRoutes.end();
-         ++i)
+    for (auto i = allRoutes.begin(); i != allRoutes.end(); ++i)
     {
         RoutingTableEntry rt;
         rt = i->second;
@@ -1192,20 +1161,20 @@
             if (rt.GetHop() == 1)
             {
                 route = rt.GetRoute();
+                NS_ASSERT(route);
                 NS_LOG_LOGIC("A route exists from " << route->GetSource()
                                                     << " to neighboring destination "
                                                     << route->GetDestination());
-                NS_ASSERT(route);
             }
             else
             {
                 RoutingTableEntry newrt;
                 m_routingTable.LookupRoute(rt.GetNextHop(), newrt);
                 route = newrt.GetRoute();
+                NS_ASSERT(route);
                 NS_LOG_LOGIC("A route exists from " << route->GetSource() << " to destination "
                                                     << route->GetDestination() << " via "
                                                     << rt.GetNextHop());
-                NS_ASSERT(route);
             }
             SendPacketFromQueue(rt.GetDestination(), route);
         }
@@ -1282,9 +1251,7 @@
     m_advRoutingTable.GetListOfAllRoutes(allRoutes);
     if (!allRoutes.empty())
     {
-        for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator i = allRoutes.begin();
-             i != allRoutes.end();
-             ++i)
+        for (auto i = allRoutes.begin(); i != allRoutes.end(); ++i)
         {
             RoutingTableEntry advEntry = i->second;
             if (advEntry.GetEntriesChanged() &&
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsdv/model/dsdv-rtable.cc ns-3.40/src/dsdv/model/dsdv-rtable.cc
--- ns-3.39/src/dsdv/model/dsdv-rtable.cc	2023-07-05 14:23:47.773427200 -0700
+++ ns-3.40/src/dsdv/model/dsdv-rtable.cc	2023-09-27 13:30:37.638839000 -0700
@@ -80,7 +80,7 @@
     {
         return false;
     }
-    std::map<Ipv4Address, RoutingTableEntry>::const_iterator i = m_ipv4AddressEntry.find(id);
+    auto i = m_ipv4AddressEntry.find(id);
     if (i == m_ipv4AddressEntry.end())
     {
         return false;
@@ -96,7 +96,7 @@
     {
         return false;
     }
-    std::map<Ipv4Address, RoutingTableEntry>::const_iterator i = m_ipv4AddressEntry.find(id);
+    auto i = m_ipv4AddressEntry.find(id);
     if (i == m_ipv4AddressEntry.end())
     {
         return false;
@@ -124,16 +124,14 @@
 bool
 RoutingTable::AddRoute(RoutingTableEntry& rt)
 {
-    std::pair<std::map<Ipv4Address, RoutingTableEntry>::iterator, bool> result =
-        m_ipv4AddressEntry.insert(std::make_pair(rt.GetDestination(), rt));
+    auto result = m_ipv4AddressEntry.insert(std::make_pair(rt.GetDestination(), rt));
     return result.second;
 }
 
 bool
 RoutingTable::Update(RoutingTableEntry& rt)
 {
-    std::map<Ipv4Address, RoutingTableEntry>::iterator i =
-        m_ipv4AddressEntry.find(rt.GetDestination());
+    auto i = m_ipv4AddressEntry.find(rt.GetDestination());
     if (i == m_ipv4AddressEntry.end())
     {
         return false;
@@ -149,12 +147,11 @@
     {
         return;
     }
-    for (std::map<Ipv4Address, RoutingTableEntry>::iterator i = m_ipv4AddressEntry.begin();
-         i != m_ipv4AddressEntry.end();)
+    for (auto i = m_ipv4AddressEntry.begin(); i != m_ipv4AddressEntry.end();)
     {
         if (i->second.GetInterface() == iface)
         {
-            std::map<Ipv4Address, RoutingTableEntry>::iterator tmp = i;
+            auto tmp = i;
             ++i;
             m_ipv4AddressEntry.erase(tmp);
         }
@@ -168,9 +165,7 @@
 void
 RoutingTable::GetListOfAllRoutes(std::map<Ipv4Address, RoutingTableEntry>& allRoutes)
 {
-    for (std::map<Ipv4Address, RoutingTableEntry>::iterator i = m_ipv4AddressEntry.begin();
-         i != m_ipv4AddressEntry.end();
-         ++i)
+    for (auto i = m_ipv4AddressEntry.begin(); i != m_ipv4AddressEntry.end(); ++i)
     {
         if (i->second.GetDestination() != Ipv4Address("127.0.0.1") && i->second.GetFlag() == VALID)
         {
@@ -184,9 +179,7 @@
                                               std::map<Ipv4Address, RoutingTableEntry>& unreachable)
 {
     unreachable.clear();
-    for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator i = m_ipv4AddressEntry.begin();
-         i != m_ipv4AddressEntry.end();
-         ++i)
+    for (auto i = m_ipv4AddressEntry.begin(); i != m_ipv4AddressEntry.end(); ++i)
     {
         if (i->second.GetNextHop() == nextHop)
         {
@@ -234,19 +227,17 @@
     {
         return;
     }
-    for (std::map<Ipv4Address, RoutingTableEntry>::iterator i = m_ipv4AddressEntry.begin();
-         i != m_ipv4AddressEntry.end();)
+    for (auto i = m_ipv4AddressEntry.begin(); i != m_ipv4AddressEntry.end();)
     {
-        std::map<Ipv4Address, RoutingTableEntry>::iterator itmp = i;
+        auto itmp = i;
         if (i->second.GetLifeTime() > m_holddownTime && (i->second.GetHop() > 0))
         {
-            for (std::map<Ipv4Address, RoutingTableEntry>::iterator j = m_ipv4AddressEntry.begin();
-                 j != m_ipv4AddressEntry.end();)
+            for (auto j = m_ipv4AddressEntry.begin(); j != m_ipv4AddressEntry.end();)
             {
                 if ((j->second.GetNextHop() == i->second.GetDestination()) &&
                     (i->second.GetHop() != j->second.GetHop()))
                 {
-                    std::map<Ipv4Address, RoutingTableEntry>::iterator jtmp = j;
+                    auto jtmp = j;
                     removedAddresses.insert(std::make_pair(j->first, j->second));
                     ++j;
                     m_ipv4AddressEntry.erase(jtmp);
@@ -291,9 +282,7 @@
     *os << std::setw(16) << "SeqNum";
     *os << std::setw(16) << "LifeTime";
     *os << "SettlingTime" << std::endl;
-    for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator i = m_ipv4AddressEntry.begin();
-         i != m_ipv4AddressEntry.end();
-         ++i)
+    for (auto i = m_ipv4AddressEntry.begin(); i != m_ipv4AddressEntry.end(); ++i)
     {
         i->second.Print(stream, unit);
     }
@@ -305,8 +294,7 @@
 bool
 RoutingTable::AddIpv4Event(Ipv4Address address, EventId id)
 {
-    std::pair<std::map<Ipv4Address, EventId>::iterator, bool> result =
-        m_ipv4Events.insert(std::make_pair(address, id));
+    auto result = m_ipv4Events.insert(std::make_pair(address, id));
     return result.second;
 }
 
@@ -314,7 +302,7 @@
 RoutingTable::AnyRunningEvent(Ipv4Address address)
 {
     EventId event;
-    std::map<Ipv4Address, EventId>::const_iterator i = m_ipv4Events.find(address);
+    auto i = m_ipv4Events.find(address);
     if (m_ipv4Events.empty())
     {
         return false;
@@ -331,7 +319,7 @@
 RoutingTable::ForceDeleteIpv4Event(Ipv4Address address)
 {
     EventId event;
-    std::map<Ipv4Address, EventId>::const_iterator i = m_ipv4Events.find(address);
+    auto i = m_ipv4Events.find(address);
     if (m_ipv4Events.empty() || i == m_ipv4Events.end())
     {
         return false;
@@ -346,7 +334,7 @@
 RoutingTable::DeleteIpv4Event(Ipv4Address address)
 {
     EventId event;
-    std::map<Ipv4Address, EventId>::const_iterator i = m_ipv4Events.find(address);
+    auto i = m_ipv4Events.find(address);
     if (m_ipv4Events.empty() || i == m_ipv4Events.end())
     {
         return false;
@@ -372,7 +360,7 @@
 EventId
 RoutingTable::GetEventId(Ipv4Address address)
 {
-    std::map<Ipv4Address, EventId>::const_iterator i = m_ipv4Events.find(address);
+    auto i = m_ipv4Events.find(address);
     if (m_ipv4Events.empty() || i == m_ipv4Events.end())
     {
         return EventId();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsdv/model/dsdv-rtable.h ns-3.40/src/dsdv/model/dsdv-rtable.h
--- ns-3.39/src/dsdv/model/dsdv-rtable.h	2023-07-05 14:23:47.773427200 -0700
+++ ns-3.40/src/dsdv/model/dsdv-rtable.h	2023-09-27 13:30:37.638839000 -0700
@@ -317,7 +317,7 @@
     /// A node does that in hope of receiving a better update.
     Time m_settlingTime;
     /// Flag to show if any of the routing table entries were changed with the routing update.
-    uint32_t m_entriesChanged;
+    bool m_entriesChanged;
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/helper/dsr-main-helper.cc ns-3.40/src/dsr/helper/dsr-main-helper.cc
--- ns-3.39/src/dsr/helper/dsr-main-helper.cc	2023-07-05 14:23:47.773427200 -0700
+++ ns-3.40/src/dsr/helper/dsr-main-helper.cc	2023-09-27 13:30:37.638839000 -0700
@@ -30,7 +30,8 @@
 
 #include "dsr-main-helper.h"
 
-#include "ns3/dsr-helper.h"
+#include "dsr-helper.h"
+
 #include "ns3/dsr-rcache.h"
 #include "ns3/dsr-routing.h"
 #include "ns3/dsr-rreq-table.h"
@@ -80,7 +81,7 @@
     NS_LOG_DEBUG("Passed node container");
     delete m_dsrHelper;
     m_dsrHelper = dsrHelper.Copy();
-    for (NodeContainer::Iterator i = nodes.Begin(); i != nodes.End(); ++i)
+    for (auto i = nodes.Begin(); i != nodes.End(); ++i)
     {
         Install(*i);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/helper/dsr-main-helper.h ns-3.40/src/dsr/helper/dsr-main-helper.h
--- ns-3.39/src/dsr/helper/dsr-main-helper.h	2023-07-05 14:23:47.773427200 -0700
+++ ns-3.40/src/dsr/helper/dsr-main-helper.h	2023-09-27 13:30:37.638839000 -0700
@@ -31,7 +31,8 @@
 #ifndef DSR_MAIN_HELPER_H
 #define DSR_MAIN_HELPER_H
 
-#include "ns3/dsr-helper.h"
+#include "dsr-helper.h"
+
 #include "ns3/dsr-routing.h"
 #include "ns3/node-container.h"
 #include "ns3/node.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/model/dsr-errorbuff.cc ns-3.40/src/dsr/model/dsr-errorbuff.cc
--- ns-3.39/src/dsr/model/dsr-errorbuff.cc	2023-07-05 14:23:47.773427200 -0700
+++ ns-3.40/src/dsr/model/dsr-errorbuff.cc	2023-09-27 13:30:37.638839000 -0700
@@ -56,9 +56,7 @@
 DsrErrorBuffer::Enqueue(DsrErrorBuffEntry& entry)
 {
     Purge();
-    for (std::vector<DsrErrorBuffEntry>::const_iterator i = m_errorBuffer.begin();
-         i != m_errorBuffer.end();
-         ++i)
+    for (auto i = m_errorBuffer.begin(); i != m_errorBuffer.end(); ++i)
     {
         NS_LOG_INFO("packet id " << i->GetPacket()->GetUid() << " " << entry.GetPacket()->GetUid()
                                  << " source " << i->GetSource() << " " << entry.GetSource()
@@ -101,9 +99,7 @@
     /*
      * Drop the packet with the error link source----------nextHop
      */
-    for (std::vector<DsrErrorBuffEntry>::iterator i = m_errorBuffer.begin();
-         i != m_errorBuffer.end();
-         ++i)
+    for (auto i = m_errorBuffer.begin(); i != m_errorBuffer.end(); ++i)
     {
         if ((i->GetSource() == link[0]) && (i->GetNextHop() == link[1]))
         {
@@ -127,9 +123,7 @@
     /*
      * Dequeue the entry with destination address dst
      */
-    for (std::vector<DsrErrorBuffEntry>::iterator i = m_errorBuffer.begin();
-         i != m_errorBuffer.end();
-         ++i)
+    for (auto i = m_errorBuffer.begin(); i != m_errorBuffer.end(); ++i)
     {
         if (i->GetDestination() == dst)
         {
@@ -148,9 +142,7 @@
     /*
      * Make sure if the send buffer contains entry with certain dst
      */
-    for (std::vector<DsrErrorBuffEntry>::const_iterator i = m_errorBuffer.begin();
-         i != m_errorBuffer.end();
-         ++i)
+    for (auto i = m_errorBuffer.begin(); i != m_errorBuffer.end(); ++i)
     {
         if (i->GetDestination() == dst)
         {
@@ -184,9 +176,7 @@
      */
     NS_LOG_DEBUG("The error buffer size " << m_errorBuffer.size());
     IsExpired pred;
-    for (std::vector<DsrErrorBuffEntry>::iterator i = m_errorBuffer.begin();
-         i != m_errorBuffer.end();
-         ++i)
+    for (auto i = m_errorBuffer.begin(); i != m_errorBuffer.end(); ++i)
     {
         if (pred(*i))
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/model/dsr-gratuitous-reply-table.cc ns-3.40/src/dsr/model/dsr-gratuitous-reply-table.cc
--- ns-3.39/src/dsr/model/dsr-gratuitous-reply-table.cc	2023-07-05 14:23:47.777427200 -0700
+++ ns-3.40/src/dsr/model/dsr-gratuitous-reply-table.cc	2023-09-27 13:30:37.638839000 -0700
@@ -67,7 +67,7 @@
 DsrGraReply::FindAndUpdate(Ipv4Address replyTo, Ipv4Address replyFrom, Time gratReplyHoldoff)
 {
     Purge(); // purge the gratuitous reply table
-    for (std::vector<GraReplyEntry>::iterator i = m_graReply.begin(); i != m_graReply.end(); ++i)
+    for (auto i = m_graReply.begin(); i != m_graReply.end(); ++i)
     {
         if ((i->m_replyTo == replyTo) && (i->m_hearFrom == replyFrom))
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/model/dsr-maintain-buff.cc ns-3.40/src/dsr/model/dsr-maintain-buff.cc
--- ns-3.39/src/dsr/model/dsr-maintain-buff.cc	2023-07-05 14:23:47.777427200 -0700
+++ ns-3.40/src/dsr/model/dsr-maintain-buff.cc	2023-09-27 13:30:37.638839000 -0700
@@ -56,9 +56,7 @@
 DsrMaintainBuffer::Enqueue(DsrMaintainBuffEntry& entry)
 {
     Purge();
-    for (std::vector<DsrMaintainBuffEntry>::const_iterator i = m_maintainBuffer.begin();
-         i != m_maintainBuffer.end();
-         ++i)
+    for (auto i = m_maintainBuffer.begin(); i != m_maintainBuffer.end(); ++i)
     {
         //      NS_LOG_INFO ("nexthop " << i->GetNextHop () << " " << entry.GetNextHop () << " our
         //      add " << i->GetOurAdd () << " " << entry.GetOurAdd ()
@@ -106,9 +104,7 @@
 DsrMaintainBuffer::Dequeue(Ipv4Address nextHop, DsrMaintainBuffEntry& entry)
 {
     Purge();
-    for (std::vector<DsrMaintainBuffEntry>::iterator i = m_maintainBuffer.begin();
-         i != m_maintainBuffer.end();
-         ++i)
+    for (auto i = m_maintainBuffer.begin(); i != m_maintainBuffer.end(); ++i)
     {
         if (i->GetNextHop() == nextHop)
         {
@@ -124,9 +120,7 @@
 bool
 DsrMaintainBuffer::Find(Ipv4Address nextHop)
 {
-    for (std::vector<DsrMaintainBuffEntry>::const_iterator i = m_maintainBuffer.begin();
-         i != m_maintainBuffer.end();
-         ++i)
+    for (auto i = m_maintainBuffer.begin(); i != m_maintainBuffer.end(); ++i)
     {
         if (i->GetNextHop() == nextHop)
         {
@@ -140,9 +134,7 @@
 bool
 DsrMaintainBuffer::AllEqual(DsrMaintainBuffEntry& entry)
 {
-    for (std::vector<DsrMaintainBuffEntry>::iterator i = m_maintainBuffer.begin();
-         i != m_maintainBuffer.end();
-         ++i)
+    for (auto i = m_maintainBuffer.begin(); i != m_maintainBuffer.end(); ++i)
     {
         //      NS_LOG_DEBUG ("nexthop " << i->GetNextHop () << " " << entry.GetNextHop () << " our
         //      address " << i->GetOurAdd () << " " << entry.GetOurAdd ()
@@ -166,9 +158,7 @@
 bool
 DsrMaintainBuffer::NetworkEqual(DsrMaintainBuffEntry& entry)
 {
-    for (std::vector<DsrMaintainBuffEntry>::iterator i = m_maintainBuffer.begin();
-         i != m_maintainBuffer.end();
-         ++i)
+    for (auto i = m_maintainBuffer.begin(); i != m_maintainBuffer.end(); ++i)
     {
         //      NS_LOG_DEBUG ("nexthop " << i->GetNextHop () << " " << entry.GetNextHop () << " our
         //      address " << i->GetOurAdd () << " " << entry.GetOurAdd ()
@@ -193,9 +183,7 @@
 DsrMaintainBuffer::PromiscEqual(DsrMaintainBuffEntry& entry)
 {
     NS_LOG_DEBUG("The maintenance buffer size " << m_maintainBuffer.size());
-    for (std::vector<DsrMaintainBuffEntry>::iterator i = m_maintainBuffer.begin();
-         i != m_maintainBuffer.end();
-         ++i)
+    for (auto i = m_maintainBuffer.begin(); i != m_maintainBuffer.end(); ++i)
     {
         //      NS_LOG_DEBUG ("src " << i->GetSrc () << " " << entry.GetSrc () << " dst " <<
         //      i->GetDst () << " " << entry.GetDst ()
@@ -220,9 +208,7 @@
 DsrMaintainBuffer::LinkEqual(DsrMaintainBuffEntry& entry)
 {
     NS_LOG_DEBUG("The maintenance buffer size " << m_maintainBuffer.size());
-    for (std::vector<DsrMaintainBuffEntry>::iterator i = m_maintainBuffer.begin();
-         i != m_maintainBuffer.end();
-         ++i)
+    for (auto i = m_maintainBuffer.begin(); i != m_maintainBuffer.end(); ++i)
     {
         //      NS_LOG_DEBUG ("src " << i->GetSrc () << " " << entry.GetSrc () << " dst " <<
         //      i->GetDst () << " " << entry.GetDst ()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/model/dsr-network-queue.cc ns-3.40/src/dsr/model/dsr-network-queue.cc
--- ns-3.39/src/dsr/model/dsr-network-queue.cc	2023-07-05 14:23:47.777427200 -0700
+++ ns-3.40/src/dsr/model/dsr-network-queue.cc	2023-09-27 13:30:37.638839000 -0700
@@ -107,9 +107,7 @@
 DsrNetworkQueue::FindPacketWithNexthop(Ipv4Address nextHop, DsrNetworkQueueEntry& entry)
 {
     Cleanup();
-    for (std::vector<DsrNetworkQueueEntry>::iterator i = m_dsrNetworkQueue.begin();
-         i != m_dsrNetworkQueue.end();
-         ++i)
+    for (auto i = m_dsrNetworkQueue.begin(); i != m_dsrNetworkQueue.end(); ++i)
     {
         if (i->GetNextHopAddress() == nextHop)
         {
@@ -125,9 +123,7 @@
 DsrNetworkQueue::Find(Ipv4Address nextHop)
 {
     Cleanup();
-    for (std::vector<DsrNetworkQueueEntry>::iterator i = m_dsrNetworkQueue.begin();
-         i != m_dsrNetworkQueue.end();
-         ++i)
+    for (auto i = m_dsrNetworkQueue.begin(); i != m_dsrNetworkQueue.end(); ++i)
     {
         if (i->GetNextHopAddress() == nextHop)
         {
@@ -158,7 +154,7 @@
 {
     NS_LOG_FUNCTION(this);
     Cleanup();
-    std::vector<DsrNetworkQueueEntry>::iterator i = m_dsrNetworkQueue.begin();
+    auto i = m_dsrNetworkQueue.begin();
     if (i == m_dsrNetworkQueue.end())
     {
         // no elements in array
@@ -182,8 +178,7 @@
 
     Time now = Simulator::Now();
     uint32_t n = 0;
-    for (std::vector<DsrNetworkQueueEntry>::iterator i = m_dsrNetworkQueue.begin();
-         i != m_dsrNetworkQueue.end();)
+    for (auto i = m_dsrNetworkQueue.begin(); i != m_dsrNetworkQueue.end();)
     {
         if (i->GetInsertedTimeStamp() + m_maxDelay > now)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/dsr/model/dsr-option-header.cc ns-3.40/src/dsr/model/dsr-option-header.cc
--- ns-3.39/src/dsr/model/dsr-option-header.cc	2023-07-05 14:23:47.777427200 -0700
+++ ns-3.40/src/dsr/model/dsr-option-header.cc	2023-09-27 13:30:37.638839000 -0700
@@ -371,9 +371,7 @@
 {
     os << "( type = " << (uint32_t)GetType() << " length = " << (uint32_t)GetLength() << "";
 
-    for (std::vector<Ipv4Address>::const_iterator it = m_ipv4Address.begin();
-         it != m_ipv4Address.end();
-         it++)
+    for (auto it = m_ipv4Address.begin(); it != m_ipv4Address.end(); it++)
     {
         os << *it << " ";
     }
@@ -398,8 +396,7 @@
     i.WriteHtonU16(m_identification);
     WriteTo(i, m_target);
 
-    for (VectorIpv4Address_t::const_iterator it = m_ipv4Address.begin(); it != m_ipv4Address.end();
-         it++)
+    for (auto it = m_ipv4Address.begin(); it != m_ipv4Address.end(); it++)
     {
         it->Serialize(buff);
         i.Write(buff, 4);
@@ -506,9 +503,7 @@
 {
     os << "( type = " << (uint32_t)GetType() << " length = " << (uint32_t)GetLength() << "";
 
-    for (std::vector<Ipv4Address>::const_iterator it = m_ipv4Address.begin();
-         it != m_ipv4Address.end();
-         it++)
+    for (auto it = m_ipv4Address.begin(); it != m_ipv4Address.end(); it++)
     {
         os << *it << " ";
     }
@@ -533,8 +528,7 @@
     i.WriteU8(0);
     i.WriteU8(0);
 
-    for (VectorIpv4Address_t::const_iterator it = m_ipv4Address.begin(); it != m_ipv4Address.end();
-         it++)
+    for (auto it = m_ipv4Address.begin(); it != m_ipv4Address.end(); it++)
     {
         it->Serialize(buff);
         i.Write(buff, 4);
@@ -666,9 +660,7 @@
 {
     os << "( type = " << (uint32_t)GetType() << " length = " << (uint32_t)GetLength() << "";
 
-    for (std::vector<Ipv4Address>::const_iterator it = m_ipv4Address.begin();
-         it != m_ipv4Address.end();
-         it++)
+    for (auto it = m_ipv4Address.begin(); it != m_ipv4Address.end(); it++)
     {
         os << *it << " ";
     }
@@ -693,8 +685,7 @@
     i.WriteU8(m_salvage);
     i.WriteU8(m_segmentsLeft);
 
-    for (VectorIpv4Address_t::const_iterator it = m_ipv4Address.begin(); it != m_ipv4Address.end();
-         it++)
+    for (auto it = m_ipv4Address.begin(); it != m_ipv4Address.end(); it++)
     {
         it->Serialize(buff);
         i.Write(buff, 4);
